%define jbhomedir %{_datadir}/jbossas
%define jbossdir %{_localstatedir}/lib/jbossas
%define logdir   %{_localstatedir}/log
%define tmpdir   %{_localstatedir}/cache
%define jbver    4.0.5.GA_CP04
%define basedir %{jbver}/jboss-4.0.x
%define bname jbossas
%define ejb3rel rc9.CP04

Summary:        JBoss Enterprise Java Beans (EJB) 3.0
Name:           jbossas-ejb3
Version:        1.0.0
Release:        0.2.rc9.CP04.el4s1.2
Epoch:          0
License:        LGPL
Group:          Internet/WWW/Servers
URL:            http://www.jboss.org/

#mkdir -p jboss-4.0.5.GA_CP04-src/4.0.5.GA_CP04/
#svn export -r 63138 https://svn.jboss.org/repos/jbossas/branches/JBoss_4_0_5_GA_CP04_EJBTHREE-798 jboss-4.0.5.GA_CP04-src/4.0.5.GA_CP04/jboss-4.0.x/
#svn export -r 63138 https://svn.jboss.org/repos/jbossas/branches/JBoss_4_0_5_GA_CP04_EJBTHREE-798/build/build-release.xml jboss-4.0.5.GA_CP04-src/build-release.xml
Source1:        jboss-%{jbver}-src.tar.gz

#ant -f build-release.xml createthirdparty
Source2:		%{bname}-4.0.x-tp.tar.gz
Source3:		%{name}-release.properties
Source4:		jbossas.init

Patch1:	       %{name}-version.patch
BuildRequires:	jpackage-utils,ant,ant-nodeps,gawk
BuildRequires:	java-1.5.0-bea-devel
Requires:		java >= 1.5
Requires:		jpackage-utils, jbossas-core >= 0:4.0.5-2.CP04.el4s1.1
Conflicts: 		jbossas

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch

%description
Enterprise Java Beans (EJB) 3 is a deep overhaul and simplification of the
EJB specification. EJB 3's goals are to simplify development, facilitate
test driven development, and focus more on writing plain old java objects
(POJOs) rather than on complex EJB APIs.

%package -n %{bname}-ejb3-jboss-repolib
Summary:	The EJB3 built artifacts uploaded to repository.jboss.com. JEMS installer is built using these artifacts.
Group:		Internet/WWW/Servers

%description -n %{bname}-ejb3-jboss-repolib
The EJB3 built artifacts uploaded to repository.jboss.com. JEMS installer is built using these artifacts.

%prep
%setup -T -q -b 1 -n jboss-%{jbver}-src
tar xzf %{SOURCE2}
cp %{SOURCE3} release.properties

# Location where the EJB3 built contents are extracted 
mkdir output
# This is where all the JDK5 specific JBoss stuff is going to be placed
mkdir -p output/javaee5/aop/client
mkdir -p output/javaee5/aop/deploy
mkdir -p output/javaee5/aop/lib
mkdir -p output/javaee5/aop/deploy/jboss-aop-jdk50.deployer
mkdir -p output/javaee5/ejb3/client
mkdir -p output/javaee5/ejb3/deploy
mkdir -p output/emptydeployfolder/deploy
mkdir -p output/javaee5/jbossws/client
mkdir -p output/javaee5/jbossws/deploy/jbossws.sar


# Link to existing jbossas-core installation
ln -s %{jbossdir} output/jboss-%{jbver}

# Add tag information to component-info.xml so the sources etc. are traceable.
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{PATCH1}

%patch1

%build

# Rebuilding the entire JBoss source tree with JDK5
pushd %{basedir}/build > /dev/null
ant -Dinhibit.downloads=true
popd > /dev/null

# Now building EJB3
pushd %{basedir}/ejb3 > /dev/null
ant repository-zip
#ant dist
popd > /dev/null

unzip %{basedir}/ejb3/output/lib/jboss-ejb3-repo.zip -d %{basedir}/thirdparty/jboss
mv %{basedir}/thirdparty/jboss/1.0.0.CR9-jboss4.0.5.GA.CP04 %{basedir}/thirdparty/jboss/ejb3

cp %{basedir}/thirdparty/jboss/aop/lib/jboss-aop-jdk50-client.jar output/javaee5/aop/client
cp %{basedir}/thirdparty/jboss/aop/lib/jboss-aspect-jdk50-client.jar output/javaee5/aop/client
unzip %{basedir}/thirdparty/jboss/aop/bin/jboss-aop-jdk50.deployer -d output/javaee5/aop/deploy/jboss-aop-jdk50.deployer 
unzip %{basedir}/thirdparty/jboss/ejb3/bin/ejb3.deployer -d output/javaee5/ejb3/deploy  
cp %{basedir}/thirdparty/jboss/ejb3/lib/hibernate-client.jar output/javaee5/ejb3/client
cp %{basedir}/thirdparty/jboss/ejb3/lib/jboss-ejb3-client.jar output/javaee5/ejb3/client
cp %{basedir}/thirdparty/jboss/ejb3/resources/*.xml output/javaee5/ejb3/deploy
unzip %{basedir}/thirdparty/jboss/jbossws/lib/jbossws.sar -d output/javaee5/jbossws/deploy/jbossws.sar 
cp  %{basedir}/thirdparty/jboss/jbossws/lib/jbossws-client.jar output/javaee5/jbossws/client

rm -f output/jboss-%{jbver}

%install
# TODO: all jars in /client need to go under jbhomedir and not jbossdir
rm -rf $RPM_BUILD_ROOT

# -jboss-repolib specific stuff
install -d -m 755 $RPM_BUILD_ROOT/jboss/ejb3
unzip %{basedir}/ejb3/output/lib/jboss-ejb3-repo.zip -d $RPM_BUILD_ROOT/jboss/ejb3
# end -jboss-repolib specific stuff

install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}
install -d -m 755 $RPM_BUILD_ROOT%{jbhomedir}/client
install -d -m 755 $RPM_BUILD_ROOT%{jbhomedir}/lib
install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/all/lib
install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/default/lib
install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/default/deploy
install -d -m 755 $RPM_BUILD_ROOT%{jbossdir}/server/all/deploy

install -m 644 output/javaee5/*/client/* $RPM_BUILD_ROOT%{jbhomedir}/client
install -m 644 %{basedir}/thirdparty/hibernate-entitymanager/lib/ejb3-persistence.jar $RPM_BUILD_ROOT%{jbhomedir}/client
install -m 644 %{basedir}/thirdparty/hibernate-annotations/lib/hibernate-annotations.jar $RPM_BUILD_ROOT%{jbhomedir}/client
install -m 644 %{basedir}/thirdparty/hibernate-entitymanager/lib/ejb3-persistence.jar $RPM_BUILD_ROOT%{jbossdir}/server/all/lib
install -m 644 %{basedir}/thirdparty/hibernate-entitymanager/lib/ejb3-persistence.jar $RPM_BUILD_ROOT%{jbossdir}/server/default/lib
install -m 644 %{basedir}/thirdparty/hibernate-entitymanager/lib/hibernate-entitymanager.jar $RPM_BUILD_ROOT%{jbossdir}/server/all/lib
install -m 644 %{basedir}/thirdparty/hibernate-entitymanager/lib/hibernate-entitymanager.jar $RPM_BUILD_ROOT%{jbossdir}/server/default/lib
install -m 644 %{basedir}/thirdparty/hibernate-annotations/lib/hibernate-annotations.jar $RPM_BUILD_ROOT%{jbossdir}/server/all/lib
install -m 644 %{basedir}/thirdparty/hibernate-annotations/lib/hibernate-annotations.jar $RPM_BUILD_ROOT%{jbossdir}/server/default/lib
install -m 644 %{basedir}/thirdparty/quartz/lib/quartz-all-1.5.2.jar $RPM_BUILD_ROOT%{jbossdir}/server/all/lib
install -m 644 %{basedir}/thirdparty/quartz/lib/quartz-all-1.5.2.jar $RPM_BUILD_ROOT%{jbossdir}/server/default/lib
cp -pr output/javaee5/ejb3/deploy $RPM_BUILD_ROOT%{jbossdir}/server/all
cp -pr output/javaee5/ejb3/deploy/ejb3.deployer $RPM_BUILD_ROOT%{jbossdir}/server/default/deploy

# TODO: check this later
cp -p output/javaee5/ejb3/deploy/ejb3-interceptors-aop.xml $RPM_BUILD_ROOT%{jbossdir}/server/default/deploy
cp -p output/javaee5/ejb3/deploy/ejb3-interceptors-aop.xml $RPM_BUILD_ROOT%{jbossdir}/server/all/deploy
cp -p output/javaee5/ejb3/deploy/ejb3.deployer/jboss-annotations-ejb3.jar $RPM_BUILD_ROOT%{jbhomedir}/client
cp -p output/javaee5/ejb3/deploy/ejb3.deployer/jboss-ejb3x.jar $RPM_BUILD_ROOT%{jbhomedir}/client

cp -pr output/javaee5/aop/deploy/jboss-aop-jdk50.deployer $RPM_BUILD_ROOT%{jbossdir}/server/all/deploy
cp -pr output/javaee5/aop/deploy/jboss-aop-jdk50.deployer $RPM_BUILD_ROOT%{jbossdir}/server/default/deploy

cp -pr output/javaee5/jbossws/deploy/jbossws.sar $RPM_BUILD_ROOT%{jbossdir}/server/all/deploy
cp -pr output/javaee5/jbossws/deploy/jbossws.sar $RPM_BUILD_ROOT%{jbossdir}/server/default/deploy

ln -s /usr/share/java/jbossas/rars/quartz-ra.rar $RPM_BUILD_ROOT%{jbossdir}/server/all/deploy
ln -s /usr/share/java/jbossas/rars/quartz-ra.rar $RPM_BUILD_ROOT%{jbossdir}/server/default/deploy

# TODO: Is this required?
install -m 644 %{basedir}/thirdparty/trove/lib/trove.jar $RPM_BUILD_ROOT%{jbhomedir}/client

install -dm 755 $RPM_BUILD_ROOT%{_javadir}/%{bname}

cp %{basedir}/thirdparty/jboss/ejb3/lib/hibernate-client.jar output/javaee5/ejb3/client
cp %{basedir}/thirdparty/jboss/ejb3/lib/jboss-ejb3-client.jar output/javaee5/ejb3/client

pushd $RPM_BUILD_ROOT > /dev/null
	for i in var/lib/jbossas/server/all/deploy/ejb3.deployer/*.jar usr/share/jbossas/client/{hibernate,jboss-ejb3}-client.jar; 
	do
		dir=""
		if [ ! -L $RPM_BUILD_ROOT/$i ]; then
			dir=$RPM_BUILD_ROOT%{_javadir}/%{bname}
			versioned=`basename $i | sed -e s:\\\\\(\\\..ar\\\\\):-%{version}-%{ejb3rel}\\\1:`
			if [ ! -L $dir/$versioned ]; then
				ln -s /$i $dir/$versioned
				ln -s $versioned $dir/`basename $i`
			fi
		fi
	done

popd > /dev/null


# We automate a large part of the file list because there are lots of files 
# involved, and maintaining them individuall would be a pain. The automation 
# may add a few secons to a built, but it is worth it considering the 
# maintenance time it saves.

rm -f ejb3-server-files
currdir=`pwd`

pushd $RPM_BUILD_ROOT
        for file in `find usr/share/jbossas/client var/lib/jbossas/server | sort`; do
	    # TODO: I dont think this is needed anymore.
            # To keep things cleaner below, strip out the leading path so that the rest 
            # of the code can assume that it is working inside of JBOSS_HOME
            file2=`echo $file | sed -e s:^var/lib/jbossas/server:server:g`
            file2=`echo $file2 | sed -e s:^usr/share/jbossas/client:client:g`

            fnamewithmacro=`echo $file | sed -e s:^var/lib/jbossas/server:'%\{jbossdir}/server':g`
            fnamewithmacro=`echo $fnamewithmacro | sed -e s:^usr/share/jbossas/client:'%\{jbhomedir}/client':g`

            if [ -d $RPM_BUILD_ROOT/$file ]; then
                echo "%attr(-,jboss,jboss) %dir $fnamewithmacro" >> $currdir/ejb3-server-files
            else
                # If this is an .xml or .properties file, it is config
                if [ "${file##*.}" == "xml" ] || [ "${file##*.}" == "properties" ]; then
                    echo "%attr(-,jboss,jboss) %config(noreplace) $fnamewithmacro" >> $currdir/ejb3-server-files
                else
                    echo "%attr(-,jboss,jboss) $fnamewithmacro" >> $currdir/ejb3-server-files 
                fi
            fi
        done

        for link in `find usr/share/java/%{bname} -type l | sort` ; do
            fnamewithmacro=`echo $link | sed -e s:^usr/share/java:'%\{_javadir}':g`
            echo "%attr(-,jboss,jboss) $fnamewithmacro" >> $currdir/ejb3-server-files
        done
popd

# Install init script
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/init.d
install -m 755 %{SOURCE4} \
			$RPM_BUILD_ROOT%{_sysconfdir}/init.d/jbossas

# Install links in /usr/bin/
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
for script in classpath probe run shutdown twiddle wstools; do
  ln -sf %{jbossdir}/bin/${script}.sh $RPM_BUILD_ROOT%{_bindir}/jbossas-${script}
done

%pre
if [ "$1" = 2 ]; then
  # stop server before upgrade
  %{_sysconfdir}/init.d/jbossas stop >/dev/null 2>&1
fi

%preun
# remove service
if [ "$1" = 0 ]; then
  # on erase
  %{_sysconfdir}/init.d/jbossas stop > /dev/null 2>&1 || :
  [ -x /sbin/chkconfig ] && chkconfig --del jbossas
fi

%post
[ -x /sbin/chkconfig ] && chkconfig --add jbossas || :

%clean
rm -rf $RPM_BUILD_ROOT

%files -f ejb3-server-files
%defattr(0644,jboss,jboss,0755)
%attr(0755,root,root) %{_sysconfdir}/init.d/jbossas
%attr(0755,root,root) %{_bindir}/*

%files -n jbossas-ejb3-jboss-repolib
%attr(-,jboss,jboss) /jboss

%changelog
* Fri May 18 2007 Deepak Bhole <dbhole@redhat.com> 1.0.0-0.2.rc9.CP04.el4s1.2
- Updated source tarball to one with the EJBTHREE-798 fix

* Thu May 10 2007 Deepak Bhole <dbhole@redhat.com> 1.0.0-0.2.rc9.CP04.el4s1.1
- Update to CP04 (see bz:238574)

* Mon Jan 22 2007 Deepak Bhole <dbhole@redhat.com> 1.0.0-0.1.rc9.el4s1.6
- Move init scripts and /usr/bin/* links out of core and put a copy here

* Fri Dec 08 2006 Deepak Bhole <dbhole@redhat.com> 1.0.0-0.1.rc9.el4s1.5
- Added a java 1.5 requirement

* Thu Dec 07 2006 Deepak Bhole <dbhole@redhat.com> 1.0.0-0.1.rc9.el4s1.4
- Add stop server to preun on erase, and to pre on upgrade

* Thu Dec 07 2006 Deepak Bhole <dbhole@redhat.com> 1.0.0-0.1.rc9.el4s1.3
- Prevent init script deletion on erase

* Thu Dec 07 2006 Deepak Bhole <dbhole@redhat.com> 1.0.0-0.1.rc9.el4s1.2
- Rebuild

* Mon Oct 30 2006 Vivek Lakshmanan <vivekl@redhat.com> 1.0.0-0.1.rc9.el4s1.1
- Initial build

